/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.grainReserves.modular.reserveQuantity.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unis.grainReserves.modular.reserveQuantity.entity.ReserveQuantityKQ;
import com.unis.grainReserves.modular.reserveQuantity.param.ReserveQuantityKQPageParam;
import org.springframework.stereotype.Service;
import com.unis.common.page.CommonPageRequest;
import com.unis.grainReserves.modular.reserveQuantity.entity.ReserveQuantity;
import com.unis.grainReserves.modular.reserveQuantity.mapper.ReserveQuantityMapper;
import com.unis.grainReserves.modular.reserveQuantity.param.ReserveQuantityPageParam;
import com.unis.grainReserves.modular.reserveQuantity.service.ReserveQuantityService;

import javax.annotation.Resource;

/**
 * 储备数量Service接口实现类
 *
 * @author QSHan
 * @date 2024/05/14 17:32
 **/
@Service
public class ReserveQuantityServiceImpl extends ServiceImpl<ReserveQuantityMapper, ReserveQuantity> implements ReserveQuantityService {
    @Resource
    private ReserveQuantityMapper reserveQuantityMapper;

    @Override
    public Page<ReserveQuantity> page(ReserveQuantityPageParam param) {
        QueryWrapper<ReserveQuantity> wrapper = new QueryWrapper<>();
        if (StringUtils.isNotEmpty(param.getZcdzCity()))
            wrapper.like("t1.cityName", param.getZcdzCity());
        if (StringUtils.isNotEmpty(param.getDwmc()))
            wrapper.like("t1.dwmc", param.getDwmc());
        if (StringUtils.isNotEmpty(param.getOrgName()))
            wrapper.like("t1.org_name", param.getOrgName());
        return reserveQuantityMapper.selectPageList(CommonPageRequest.defaultPage(), wrapper);
    }

    @Override
    public Page<ReserveQuantityKQ> storagePage(ReserveQuantityKQPageParam param) {
        QueryWrapper<ReserveQuantityKQ> wrapper = new QueryWrapper<>();
        if (StringUtils.isNotEmpty(param.getStorehouseName()))
            wrapper.like("bs.storehouse_name", param.getStorehouseName());
        if (StringUtils.isNotEmpty(param.getPzName()))
            wrapper.like("be.enumname", param.getPzName());
        if (StringUtils.isNotEmpty(param.getHwxzName()))
            wrapper.like("be1.enumname", param.getHwxzName());
        if (StringUtils.isNotEmpty(param.getDjName()))
            wrapper.like("be2.enumname", param.getDjName());
        if (StringUtils.isNotEmpty(param.getUnitId()))
            wrapper.eq("kkd.UnitID", param.getUnitId());
        return reserveQuantityMapper.storagePage(CommonPageRequest.defaultPage(), wrapper);
    }

}
